#!/bin/bash
# Switch the timezone of the OS to the value given in the first argument.
# Returns 0 on success, non-zero on failure.

if [[ $# != 1 ]]; then
    echo "Usage: `basename $0` <timezone>"
    exit 1
fi

# Ensure the requested timezone is valid
if ! /home/maint/scripts/get-available-timezones.sh | grep -qw $1; then
    echo "Timezone not found: $1"
    exit 1
fi

mv /etc/timezone /etc/timezone.`date "+%Y-%m-%d_%H:%M"`
echo $1 >> /etc/timezone
dpkg-reconfigure tzdata -fnoninteractive > /dev/null 2>&1 \
    && echo "Timezone changed.  Time is now `date +'%H:%M:%S %z'`"

