#!/usr/bin/perl

###############################################################################
# Find the network ethernet interface
###############################################################################
# Find the first ethernet interface
my $ETHERNET_INTERFACE="eth0";
open(FH, "/bin/ls -1 /sys/class/net |") or die "Could not run /bin/ls: $?\n";
while(<FH>) {
     chomp;
     if ($_ =~ /^(e.*)/) {
         $ETHERNET_INTERFACE = $1;
         last;
     }
}
close(FH);

#Asks the user a yes/no question
#Returns 1 for yes, 0 for no
sub user_confirm {
    my $question = shift @_;
    my $default = shift @_;

    while(1) {
        print "$question [$default]: ";

        my $answer = <STDIN>;
        chomp $answer;

        #if they didnt enter anything, use the default
        if($answer eq "") {
            $answer = $default;
        }

        #figure out if they entered yes or no
        if ($answer =~ /^(y|yes)$/i) {
            return 1;
        } elsif ($answer =~ /^(n|no)$/i) {
            return 0;
        } else {
            print "Please answer yes or no.\n";
        }
    }
}

if (!user_confirm("Would you like to reset network settings to the factory default?", 'y')) {
    exit 0;
}

open (IFACE_FILE, "<", "/etc/network/interfaces");

my $out_file = "";

while(my $line = <IFACE_FILE>) {
    if($line =~ /^iface $ETHERNET_INTEFACE/) {
        while($line = <IFACE_FILE>) {
            if(!($line =~ /^\t/)) {
                last;
            }
        }

        $out_file .= "iface $ETHERNET_INTERFACE inet dhcp\n";
    }
    $out_file .= $line;
}

close (IFACE_FILE);
open (OUTPUT_FILE, ">", "/etc/network/interfaces");
print OUTPUT_FILE $out_file;
close (OUTPUT_FILE);

system("touch /var/lib/fmc/.run_network_config");

if (!user_confirm("You need to restart the system to apply changes.\nWould you like to restart now?", 'y')) {
    exit 0;
}

system("reboot");
