#!/bin/bash

protcolToDisable=$1

function readProperty(){
	local PROP_VALUE=`cat $PROPERTY_FILE | grep  "^$PROP_KEY" | cut -d'=' -f2` 
	echo "$PROP_VALUE"
}
javalink=`which java`
javapath=`readlink -f $javalink`
javadir=`dirname $javapath`
javabin=`dirname $javadir`
PROPERTY_FILE=$javabin/conf/security/java.security
PROP_KEY='jdk.tls.disabledAlgorithms'
VALUE=$(readProperty)
AllPROTOCOL=(TLSv1.1 TLSv1 TLSv1.2)
new_array=()
args=()


function addToDisabledProtocol(){
	matched=""
	set -f                      # avoid globbing (expansion of *).
	array=(${VALUE//,/ })
	
	if [ "${#array[@]}" -gt 1 ]
	then
	
	for i in "${!array[@]}"
	do
		if [ "${array[i]}" == "$protcolToDisable" ] 
		then
		matched="matched"
		fi
	done

	for i in "${!array[@]}"
	do
		for j in "${!AllPROTOCOL[@]}"
		do
			if [ "${array[i]}" == "${AllPROTOCOL[j]}" ]
			then
			if [ "$args" == "" ]
			then
				args+="${AllPROTOCOL[j]}"
			else 
				args+=$'\n'"${AllPROTOCOL[j]}"
			fi

				unset "AllPROTOCOL[j]"
			fi
		done
	done

  argsarray=(${args//\n/ })
 
	for i in "${!argsarray[@]}"
	do
		if [ "${argsarray[i]}" == "$protcolToDisable" ] 
		then
		echo "PROTOCOL DISABLE FAILURE REASON : $protcolToDisable is already disabled";
		exit 1
		fi
	done

    	if [ "${#argsarray[*]}" -ge 2 ]
		then
		echo "PROTOCOL DISABLE FAILURE REASON : At least one protocol should be enabled";
		exit 1
	fi
	
	if [ "$matched" == "" ] 
		then
		sed -i "s/$PROP_KEY=$VALUE\/$PROP_KEY=$protcolToDisable,$VALUE\/" "$PROPERTY_FILE"
		fi
	fi


}
addToDisabledProtocol
