#!/bin/bash

# $Id: $
# Copyright (c) 2018 NetApp, Inc.
# All rights reserved.

cd /opt/netapp/vpserver/logs
logs_to_be_compressed=$(ls vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9] | wc -l 2>/dev/null)

while [ $logs_to_be_compressed -gt 0 ]
do
        log_to_be_compressed=$(ls vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9] | tail -1 2>/dev/null) 
        tar -zcf /opt/netapp/vpserver/logs/$log_to_be_compressed.tar.gz /opt/netapp/vpserver/logs/$log_to_be_compressed 2>/dev/null
        rm -rf /opt/netapp/vpserver/logs/$log_to_be_compressed
        logs_to_be_compressed=$(ls vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9] | wc -l 2>/dev/null)
done

vvolvp_log_count=$(ls vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9].tar.gz | wc -l 2>/dev/null)

total_size_vvol_tar=$(du vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9].tar.gz | awk '{ total += $1 }; END { print total }' 2>/dev/null)

while (( $vvolvp_log_count > 24 || $(bc <<< "$total_size_vvol_tar > 10485760") > 0 ))
do
        log_to_be_rotated=$(ls -t vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9].tar.gz | tail -1 2>/dev/null)
        rm -rf /opt/netapp/vpserver/logs/$log_to_be_rotated
        vvolvp_log_count=$(ls vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9].tar.gz | wc -l 2>/dev/null)
        total_size_vvol_tar=$(du vvolvp.log.[0-9][0-9][0-9][0-9]-*-[0-9][0-9].tar.gz | awk '{ total += $1 }; END { print total }' 2>/dev/null)
done
